Loading...
Searching...
No Matches
AlterableGraphComponent< BAS > Class Template Reference

## Detailed Description

template<typename BAS = BaseGraphComponent>
class lemon::concepts::AlterableGraphComponent< BAS >

This class describes the interface of alterable undirected graphs. It extends AlterableDigraphComponent with the alteration notifier interface of undirected graphs. It implements an observer-notifier pattern for the edges. More obsevers can be registered into the notifier and whenever an alteration occured in the graph all the observers will be notified about it.

`#include <lemon/concepts/graph_components.h>`

Inheritance diagram for AlterableGraphComponent< BAS >:
[legend]

## Public Types

typedef AlterationNotifier< AlterableGraphComponent, Edge > | EdgeNotifier
| Edge alteration notifier class.
Public Types inherited from AlterableDigraphComponent< BaseGraphComponent >
typedef AlterationNotifier< AlterableDigraphComponent, Node > | NodeNotifier
| Node alteration notifier class.
typedef AlterationNotifier< AlterableDigraphComponent, Arc > | ArcNotifier
| Arc alteration notifier class.
Public Types inherited from BaseDigraphComponent
typedef GraphItem< 'n'> | Node
| Node class of the digraph.
typedef GraphItem< 'a'> | Arc
| Arc class of the digraph.

## Public Member Functions

EdgeNotifier & | notifier (Edge) const
| Return the edge alteration notifier.
NodeNotifier & | notifier (Node) const
| Return the node alteration notifier.
ArcNotifier & | notifier (Arc) const
| Return the arc alteration notifier.
Public Member Functions inherited from AlterableDigraphComponent< BaseGraphComponent >
NodeNotifier & | notifier (Node) const
| Return the node alteration notifier.
Public Member Functions inherited from BaseGraphComponent
Node | u (const Edge &) const
| Return one end node of an edge.
Node | v (const Edge &) const
| Return the other end node of an edge.
Arc | direct (const Edge &, bool) const
| Return a directed arc related to an edge.
Arc | direct (const Edge &, const Node &) const
| Return a directed arc related to an edge.
bool | direction (const Arc &) const
| Return the direction of the arc.
Arc | oppositeArc (const Arc &) const
| Return the opposite arc.
Public Member Functions inherited from BaseDigraphComponent
Node | source (const Arc &) const
| Return the source node of an arc.
Node | target (const Arc &) const
| Return the target node of an arc.
Node | oppositeNode (const Node &, const Arc &) const
| Return the opposite node on the given arc.

## Member Function Documentation

## notifier() [1/3]

template<typename BAS = BaseGraphComponent>

EdgeNotifier & notifier | ( | Edge |  | ) | const

inline

This function gives back the edge alteration notifier.

## notifier() [2/3]

template<typename BAS = BaseGraphComponent>

NodeNotifier & notifier | ( | Node |  | ) | const

inline

This function gives back the node alteration notifier.

## notifier() [3/3]

template<typename BAS = BaseGraphComponent>

ArcNotifier & notifier | ( | Arc |  | ) | const

inline

This function gives back the arc alteration notifier.